<?php
/************************************************************************
	MovableType with AmazonWebService
	@see http://www.magicvox.net/archive/2005/08312245.php
************************************************************************/

// Amazon Associates ID
define ("MTAWS_AMAZON_ASSOCIATE_TOKEN",	'pirolirandoml-22');

// _t̊m
define ("MTAWS_RANDOM_DONATE_RATE",		10 /**/); // [0, 100]̐l

// o͂镶R[h
define ("MTAWS_OUTPUT_CHARSET",			'SJIS');

// iLbV̕ۑfBNg
define ("MTAWS_CACHE_PATH",				'/home/magicvox/www_data/MTAmazonCache');

// iLbV̎
define ("MTAWS_CACHE_EXPIRE_TIME",		7 * 24 * 60 * 60 /*b*/);



////////////////////////////////////////////////////////////////////////
// XML Parser @see http://www.php.net/manual/ja/function.xml-parse.php#35708
class XMLParser {
	var $path;
	var $tree;

	function XMLParser ($data, $encoding = 'UTF-8') {
		$this->path = "\$this->tree";
		$this->index = 0;

		$xml_parser = xml_parser_create ($encoding);
		xml_set_object ($xml_parser, &$this);
		xml_set_element_handler ($xml_parser, 'startElement', 'endElement');
		xml_set_character_data_handler ($xml_parser, 'characterData');
		$data = preg_replace ('/\s*([<>])\s*/s', '\1', $data);
		if (! xml_parse ($xml_parser, $data, true))
			$this->result = null;
		xml_parser_free($xml_parser);
	}

	function startElement ($parser, $tag, $attributeList) {
		eval ("\$vars = get_object_vars (". $this->path. ");");
		$this->path .= "->". $tag;
		if ($vars and array_key_exists ($tag, $vars)) {
			eval ("\$data = ". $this->path. ";");
			if (is_array ($data)) {
				$index = sizeof ($data);
				$this->path .= "[". $index. "]";
			} else {
				eval ($this->path. " = array (". $this->path. ");");
				$this->path .= "[1]";
			}
		}
		eval ($this->path. " = null;");

		foreach ($attributeList as $name => $value) {
			$name = preg_replace ('/[^\w]/', '', $name);
			eval ($this->path. "->". $name. " = \"". addslashes ($value). "\";");
		}
	}

	function endElement ($parser, $tag) {
		$this->path = substr ($this->path, 0, strrpos ($this->path, "->"));
	}

	function characterData ($parser, $inner) {
		eval ("\$data = ". $this->path. ";");
		eval ($this->path. ($data ? ".=\"" : "=\""). addslashes ($inner). "\";");
	}
}

////////////////////////////////////////////////////////////////////////

// AWS Developer Token of Piroli YUKARINOMIYA <piroli@magicvox.net>
define ("MTAWS_AMAZON_DEVELOPER_TOKEN",	'0X3NZ7ZSBTS9VBX99EG2');

// LbV擾
function amazonGetCache ($url) {
	if (! is_dir (MTAWS_CACHE_PATH))
		return null; // LbVȂ
	$filename = MTAWS_CACHE_PATH. '/'. md5 ($url);
	if (! file_exists ($filename))
		return null; // LbV
	if (filemtime ($filename) + MTAWS_CACHE_EXPIRE_TIME < time ())
		return null; // LbV؂
	return file_get_contents ($filename);
}

// LbVɏo
function amazonCreateCache ($url, $content) {
	if (is_dir (MTAWS_CACHE_PATH)) {
		$fp = fopen (MTAWS_CACHE_PATH. '/'. md5 ($url), 'w');
		if ($fp) {
			fwrite ($fp, $content);
			fclose ($fp);
		}
	}
}

// HTTP NGXg
function amazonGetHTTP ($url) {
	$fp = fopen ($url, 'r');
	if (! $fp)
		return null;
	$response = '';
	while (! feof ($fp))
		$response .= fgets ($fp);
	fclose ($fp);
	return $response;
}

// NGXgs
function amazonGetRequest ($url) {
	// XML 擾 (LbV -> HTTP GET)
	$response = amazonGetCache ($url);
	if (! $response) {
		$response = amazonGetHTTP ($url);
		if (! $response)
			return FALSE;
		amazonCreateCache ($url, $response);
	}

	// XML -> array
	global $xml;
	$xml = new XMLParser ($response);
	if (! $xml || ! $xml->tree)
		return FALSE;
	return TRUE;
}

// _t @see nRandomDonateRate
function amazonRandomDonate ($url) {
	mt_srand (/*Ô*/);
	if (mt_rand (1, 100) <= MTAWS_RANDOM_DONATE_RATE)
		return str_replace ('/'.MTAWS_AMAZON_ASSOCIATE_TOKEN, '/pirolirandoml-22', $url);
	return $url;
}

// UTF-8 ̕R[hɕϊ
function mbconv ($src) {
	return mb_convert_encoding ($src, MTAWS_OUTPUT_CHARSET, 'UTF-8');
}

////////////////////////////////////////////////////////////////////////

// L[[hɂ錟
function amazonKeywordSearch ($szCatalog, $szKeyword) {
	$url = 'http://webservices.amazon.co.jp/onca/xml3?type=heavy&f=xml&locale=jp';
	$url .= '&dev-t='. MTAWS_AMAZON_DEVELOPER_TOKEN;
	$url .= '&t='. MTAWS_AMAZON_ASSOCIATE_TOKEN;
	$url .= '&mode='. $szCatalog;
	$url .= '&KeywordSearch='. $szKeyword;
	return amazonGetRequest ($url);
}

// ASIN ɂʏiւ̃N
function amazonAsinSearch ($szAsin) {
	$url = 'http://webservices.amazon.co.jp/onca/xml3?type=heavy&f=xml&locale=jp';
	$url .= '&dev-t='. MTAWS_AMAZON_DEVELOPER_TOKEN;
	$url .= '&t='. MTAWS_AMAZON_ASSOCIATE_TOKEN;
	$url .= '&AsinSearch='. $szAsin;
	return amazonGetRequest ($url);
}

////////////////////////////////////////////////////////////////////////

// w肳ꂽf[^𒊏o
function amazonGetRatingImageUrl ($r) {
	if (empty ($r))
		return 'http://images-jp.amazon.com/images/G/09/other/stars-3-0.gif" style="display: none;';
	$r += 0.25;
	$r -= ($r1 = intval ($r));
	$r2 = 0.5 <= $r ? 5 : 0;
	return sprintf ('http://images-jp.amazon.com/images/G/09/other/stars-%d-%d.gif', $r1,$r2);
}
function amazonUrl ($item = 0) {
	global $xml;
	if (is_array ($xml->tree->PRODUCTINFO->DETAILS))
		return mbconv (amazonRandomDonate ($xml->tree->PRODUCTINFO->DETAILS[$item]->URL));
	else
		return mbconv (amazonRandomDonate ($xml->tree->PRODUCTINFO->DETAILS->URL));
}
function amazonAsin ($item = 0) {
	global $xml;
	if (is_array ($xml->tree->PRODUCTINFO->DETAILS))
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS[$item]->ASIN);
	else
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS->ASIN);
}
function amazonProductName ($item = 0) {
	global $xml;
	if (is_array ($xml->tree->PRODUCTINFO->DETAILS))
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS[$item]->PRODUCTNAME);
	else
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS->PRODUCTNAME);
}
function amazonCatalog ($item = 0) {
	global $xml;
	if (is_array ($xml->tree->PRODUCTINFO->DETAILS))
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS[$item]->CATALOG);
	else
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS->CATALOG);
}
function amazonCatalogImageUrl ($item = 0) {
	$arIcon = array (
			'book' => 'icon-books',
			'dvd' => 'icon-dvd',
			'electronics' => 'icon-ce',
			'music' => 'icon-music',
			'software' => 'icon-software',
			'toy' => 'mini-toys-icon-23x23',
	null);
	return sprintf ('http://images-jp.amazon.com/images/G/09/icons/%s.gif',
			$arIcon[strtolower (amazonCatalog ($item))]);
}
function amazonReleaseDate ($item = 0) {
	global $xml;
	if (is_array ($xml->tree->PRODUCTINFO->DETAILS))
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS[$item]->RELEASEDATE);
	else
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS->RELEASEDATE);
}
function amazonManufacturer ($item = 0) {
	global $xml;
	if (is_array ($xml->tree->PRODUCTINFO->DETAILS))
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS[$item]->MANUFACTURER);
	else
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS->MANUFACTURER);
}
function amazonImageUrlSmall ($item = 0) {
	global $xml;
	if (is_array ($xml->tree->PRODUCTINFO->DETAILS))
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS[$item]->IMAGEURLSMALL);
	else
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS->IMAGEURLSMALL);
}
function amazonImageUrlMedium ($item = 0) {
	global $xml;
	if (is_array ($xml->tree->PRODUCTINFO->DETAILS))
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS[$item]->IMAGEURLMEDIUM);
	else
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS->IMAGEURLMEDIUM);
}
function amazonImageUrlLarge ($item = 0) {
	global $xml;
	if (is_array ($xml->tree->PRODUCTINFO->DETAILS))
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS[$item]->IMAGEURLLARGE);
	else
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS->IMAGEURLLARGE);
}
function amazonListPrice ($item = 0) {
	global $xml;
	if (is_array ($xml->tree->PRODUCTINFO->DETAILS))
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS[$item]->LISTPRICE);
	else
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS->LISTPRICE);
}
function amazonOurPrice ($item = 0) {
	global $xml;
	if (is_array ($xml->tree->PRODUCTINFO->DETAILS))
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS[$item]->OURPRICE);
	else
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS->OURPRICE);
}
function amazonSalesRank ($item = 0) {
	global $xml;
	if (is_array ($xml->tree->PRODUCTINFO->DETAILS))
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS[$item]->SALESRANK);
	else
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS->SALESRANK);
}
function amazonAvailability ($item = 0) {
	global $xml;
	if (is_array ($xml->tree->PRODUCTINFO->DETAILS))
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS[$item]->AVAILABILITY);
	else
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS->AVAILABILITY);
}
function amazonAvgCustomerRating ($item = 0) {
	global $xml;
	if (is_array ($xml->tree->PRODUCTINFO->DETAILS))
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS[$item]->REVIEWS->AVGCUSTOMERRATING);
	else
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS->REVIEWS->AVGCUSTOMERRATING);
}
function amazonAvgCustomerRatingImageUrl ($item = 0) {
	return amazonGetRatingImageUrl (amazonAvgCustomerRating ($item));
}
function amazonTotalCustomerReviews ($item = 0) {
	global $xml;
	if (is_array ($xml->tree->PRODUCTINFO->DETAILS))
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS[$item]->REVIEWS->TOTALCUSTOMERREVIEWS);
	else
		return mbconv ($xml->tree->PRODUCTINFO->DETAILS->REVIEWS->TOTALCUSTOMERREVIEWS);
}
function amazonCustomerReviewRating ($item = 0, $index = 0) {
	global $xml;
	$detail = $xml->tree->PRODUCTINFO->DETAILS;
	if (is_array ($detail))
		$detail = $xml->tree->PRODUCTINFO->DETAILS[$item];
	if (is_array ($detail->REVIEWS->CUSTOMERREVIEW))
		return mbconv ($detail->REVIEWS->CUSTOMERREVIEW[$index]->RATING);
	else
		return mbconv ($detail->REVIEWS->CUSTOMERREVIEW->RATING);
}
function amazonCustomerReviewRatingImageUrl ($item = 0, $index = 0) {
	return amazonGetRatingImageUrl (amazonCustomReviewRating ($item = 0, $index = 0));
}
function amazonCustomerReviewSummary ($item = 0, $index = 0) {
	global $xml;
	$detail = $xml->tree->PRODUCTINFO->DETAILS;
	if (is_array ($detail))
		$detail = $xml->tree->PRODUCTINFO->DETAILS[$item];
	if (is_array ($detail->REVIEWS->CUSTOMERREVIEW))
		return mbconv ($detail->REVIEWS->CUSTOMERREVIEW[$index]->SUMMARY);
	else
		return mbconv ($detail->REVIEWS->CUSTOMERREVIEW->SUMMARY);
}
function amazonCustomerReviewComment ($item = 0, $index = 0) {
	global $xml;
	$detail = $xml->tree->PRODUCTINFO->DETAILS;
	if (is_array ($detail))
		$detail = $xml->tree->PRODUCTINFO->DETAILS[$item];
	if (is_array ($detail->REVIEWS->CUSTOMERREVIEW))
		return mbconv ($detail->REVIEWS->CUSTOMERREVIEW[$index]->COMMENT);
	else
		return mbconv ($detail->REVIEWS->CUSTOMERREVIEW->COMMENT);
}

function amazonHasResult ($item) { return amazonUrl ($item); }
function amazonHasReview ($item, $index) { return amazonCustomerReviewRating ($item, $index); }
?>
